# Types

## Reference shapes

```@meta
CurrentModule = Elfel
```


```@docs
RefShapes.AbstractRefShape
RefShapes.RefShapePoint
RefShapes.RefShapeInterval
RefShapes.RefShapeSquare
RefShapes.RefShapeCube
RefShapes.RefShapeTriangle
RefShapes.RefShapeTetrahedron
RefShapes.IntegRule
```


## Elements

```@docs
FElements.FE
FElements.FEData
```

## Fields

```@docs
FEFields.FEField
```

## Spaces

```@docs
FESpaces.FESpace
```

## Finite element iterators

```@docs
FEIterators.FEIterator
```

## Quadrature-point iterators

```@docs
QPIterators.QPIterator
```

## Assemblers

```@docs
Assemblers.AbstractSysmatAssembler
Assemblers.SysmatAssemblerSparse
Assemblers.AbstractSysvecAssembler
Assemblers.SysvecAssembler
```

## Local Assemblers

```@docs
LocalAssemblers.LocalMatrixAssembler
LocalAssemblers.LocalVectorAssembler
```

## Index

```@index
```

